
;[ eXtended 4mode code for 486 PC-9821 ]
;----------------------------------------------------------------------------
; PC-9821(Ap,As,Ae) IDE BIOS patch Version 5.20B (C) 2018-21,25 ܂
;----------------------------------------------------------------------------
NEW_ENTRY       equ     1080h
MEMseg          equ     5800h   ; < 8000h
IDE_equip       equ     10h     ; IDE BIOS bit
E10_equip       equ     20h     ; E10 BIOS bit(X-mateł͗v)  
SND_equip       equ     80h     ; SND BIOS bit(A-mate,FELLOW)

; D800:2100 block is not used on this model.
WORK_H_S        equ     2060h   ; WORD  higher byte=HEAD,Lower=SECT
WORK_HS_MUL     equ     2064h   ; WORD
WORK_CYL        equ     2042h ; as same as [2042h]
LogiSectN       equ     2046h   ; BYTE/WORD
LogiHeadN       equ     2047h   ; BYTE
PhysSectN       equ     2066h   ; BYTE/WORD
PhysHeadN       equ     2067h   ; BYTE
LBA_by_CHS      equ     2068h   ; DWORD(WORD)
LBA_by_CHS_H    equ     206Ah   ;      (WORD)
LIM_65535HS     equ     206Ch   ; DWORD(WORD)
LIM_65535HS_H   equ     206Eh   ;      (WORD)

MSG_DISP_LINE   equ     14      ; \JnsłBKXĂB
; Global stack variables -----------------
COLOR_ATTRIB    equ     byte ptr [bp-3] ; \F
SegTVRAM        equ     word ptr [bp-4] ; T-VRAM̃ZOgA000/E000
ROW             equ     word ptr [bp-6] ; \s
COLUMN          equ     word ptr [bp-8] ; \J
StartLine       equ     byte ptr [bp-10] ; \line
WORK0457        equ     byte ptr [bp-11] ; system work area
HiresoFlag      equ     byte ptr [bp-12] ; 01h Hi-reso flag (bit 0)
MachineType     equ     byte ptr [bp-13] ; [1]=Ap/Ae, [2]=BX/BA  [3]=Ce?
equip           equ     byte ptr [bp-14] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
ModeID          equ     byte ptr [bp-15] ; ݂̃p[^[h
MemWindowAddr   equ     byte ptr [bp-16] ; 08-BANK window address in EXROM
MachineID       equ     byte ptr [bp-17] ; Machine ID
MemWindowNative equ     byte ptr [bp-18] ; 08-BANK window native address
mem_bank_IOaddr equ     word ptr [bp-20] ; 0461h/0091h(nC])
SegPhysIDEBIOS  equ     word ptr [bp-22] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-24] ; IDE BIOSZOgiRAMmappingj
LHsum           equ     word ptr [bp-26] ; system work area

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
                org 103h        ; ""
DefaultModeEx   DB      01h
title_msg       DB      0E1h,"IDE HDDeʏgCHSp[^ύX  V5.20B  @",0
machine_typeA1  DB      0E1h,"Ap,As,Ae",13,10,0
machine_typeB1  DB      0E1h,"BA,BX",13,10,0
machine_typeC1  DB      0E1h,"Ce?",13,10,0
machine_typeUN  DB      0C1h,"s",13,10,0
;----------------------------------------------------------------------------
IDE_msg         DB      0E1h,"IDE BIOS݂܂. ",13,10,0
absent_msg      DB      041h,"IDE BIOSoĂ܂ifBXN̐ڑj"
wrong_bios      DB     0C1h,"ΉȂBIOSł. ",0
wrong_msg       DB     041h,"̋@ɂ͑Ή܂.",13,10,0
msg_Sector256B  DB      41h,"ZN^256oCgɐݒ肳Ă܂. ",0
msg_AvoidPatch  DB     0E1h," pb`𒆎~܂.",13,10,0
FixedSYSBIOS    DB     0E1h," SYSTEM BIOS C.",13,10,0
msg_CRLF        DB     0E1h," ",13,10,0

.186
program_start:
mov dx,1E8Eh
mov al,81h
out dx,al

                enter   32,0
                mov     COLOR_ATTRIB,0E1h
                cld
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
; XCb`̐ݒ݂
                mov     al,es:[3FF6h]   ; XCb`U̎w
                and     al,00000111b    ; }XN
                or      al,al           ; XCb`ÔƂftHg
                jnz     @f
                mov     al,1
        @@:     mov     ModeID,al       ; XCb`gpȂ炻ɏ]
                xor     ax,ax           ; AL=0
                mov     equip,al        ; bit̏l
                mov     MachineType,al  ; =0
.386
                call    GetSeg_IDEBIOS  ; ^,RAMIDE BIOSZOg𓾂 2018-12-11V
                call    ModelCheckAB1   ; @풲
                pushf
                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                call    DisplayTitle    ; ^Cg\
                popf
                jc      WrongMachine

                call    Scan_GRPH_FK6   ; 2024-3-25 ǉidlύXj 
                jc      ToAvoid
                call    DisplayParamMode6    ; p[^[h̕\6
                jc      AvoidPatch      ; CY=G[ŏI

                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      ExitProgram     ; CY=G[Œ~
                call    Sector256Byte   ; BIOSZN^𒲍
                jc      AvoidPatch      ; CY=G[ŏI

                cmp     MachineType,0
                jz      WrongMachine

                call    NOPCI_Check     ; PCI BIOS邩HCY
                jc      WrongMachine    ; CYĂ΋@ႢŃG[
                call    PeriEnvCheck    ; 486@ƔfROM`FbN
                jc      WrongMachine    ; CY=G[Œ~

                call    DisplayEquip

                call    ROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB

                call    Patch_A_B       ; Ap/As/Ae  BX/BÃpb`
                jc      WrongBIOS
;                call    SetChkSum

                call    MEMtoIDEBIOS    ; ̍ƌʂRAM BIOSɃRs[
;;              call    ClearMEMseg     ; ƃNAđދ
;call Poop
ExitProgram:
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~
                call    SetDisplayLine
                leave
                RET    ; near ^[ŏI
;-------------------------------------------
WrongMachine:   mov     dx,offset wrong_msg 
                call    _puts           ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
WrongBIOS:      mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
ToAvoid:        call    _puts
AvoidPatch:     mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts
                jmp     ExitProgram
;----------------------------------------------------------------
;       PeriEnvCheck ( equiped peripherals ) Ap3,As3,BA3,BX3 only
;----------------------------------------------------------------
PeriEnvCheck    PROC    near
; port F0h      1= HDD/IF Ȃ ,  0=HDD/IF  _
; bit 6: ^Cv(SCSI)HDDXe[^X            40h 
; bit 5: ^Cv(SASI,IDE)HDDXe[^X        20h
                in      al,0F0h
                test    al,20h          ; Internal SASI/IDE exist?
;                jnz     noequip_ide    ; ̃vOłIDE BIOS
;                jnz     IDE_absent      ; ȂƂ̂̓G[ƂȂ
                OR      equip,IDE_equip
noequip_ide:    test    al,40h          ; SCSI(A-mate)݂͑邩?
                jnz     noequip_E10_FA02        ; 2019-1-21
;                cmp     MachineType,3   ; Xe,Xs,XpI/O F0 flag bit6̈Ӗ
;                je      noequip_E10_FA02   ; Ⴄ悤Ȃ̂Œ!!
                OR      equip,E10_equip
noequip_E10_FA02:
                test    HiresoFlag,1    ; nC]Ȃ疳
                jnz     noequip_sndbios ; SOUND BIOS݂͑ȂƂ
IF 0    ; SDIPSWɂ@iA-matesj
                mov     dx,841Eh        ; DIP switch 𒲂ׂɍs@g
                in      al,dx
                test    al,02h          ; bit 1: Undoc2 ƈႤ̂Œ
                jz      noequip_sndbios ; Ap,As,Aeł͕ʂ̌o@I
                or      equip,SND_equip 
ENDIF
IF 0    ; ROM̃f[^`FbNɂ@iRAMROM̔ʂ͂łȂj
                cmp     MachineType,3
                jne     @f
                mov     ax,0CC00h
                push    es
                mov     es,ax
                mov     eax,es:[0]
                pop     es
                cmp     eax,0FFFFFFFFh  ; LROM/RAMH
                je      equip_sndbios_e
                or      eax,eax         ; 0Ŗ܂ĂRAM(UMB)
                jz      equip_sndbios_e ; ɂĂLROM͂Ȃ
                or      equip,SND_equip ;
        @@:
ENDIF
IF 1    ; A-mateL̕sVXeɂ@ 2024/4/8 
                cmp     MachineType,1
                jne     equip_sndbios_e
                mov     dx,046Ch
                mov     al,02h
                out     dx,al
                mov     dx,0468h
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx   ; KTAœǂݏo
;               mov     SwDIPSW,al
                test    al,1    ; SOUND BIOSLbit 0, ڑtL bit 2
                jNz      equip_sndbios_e ; SOUND BIOSL
                or      equip,SND_equip ;
ENDIF
equip_sndbios_e: 
noequip_sndbios:    ; SASI BIOSׂ͒ȂifBXNڑjbggp֎~j
                clc
                ret
IDE_absent:     stc
                ret
PeriEnvCheck    ENDP

;--------------------------------------------------------
;       machines
;--------------------------------------------------------
include fixbios.s
include patch0.s
include ap_ba.s

;--------------------------------------------------------
;       MEMtoIDEBIOS    5C00:0-->D800:0
;--------------------------------------------------------
MEMtoIDEBIOS    PROC   near
                pushf
                cli     ; BIOSRAMւ̓]͊荞݋֎~Ƃ
                call    ROMRAM486_IDE   ; ݒALbVtbV
                call    MEMtoROM        ; MEM̃f[^RAMBIOSɃRs[
                cmp     MachineType,2
                jne     @f
                call    FixSYSBIOS      ; SYSTEM BIOSłɉς
        @@:
                call    RAMROM486_IDE   ; sݒALbVtbV
                popf
                ret     ; G[Ԓl͂Ȃ̂Ƃ
MEMtoIDEBIOS    ENDP

IF 1
;--------------------------------------------
;       DisplayEquip    
;--------------------------------------------
DisplayEquip    PROC   near
                push    ROW
                push    COLUMN
                dec     ROW
                dec     ROW
                mov     COLUMN,69
                mov     dx,offset msg_equip1
                call    _puts
                inc     ROW
                mov     COLUMN,70
                mov     dx,offset msg_equip2
                call    _puts

                mov     al,equip ; Internal IDE,SCSI,SND BIOS enable
                call    digit_bit4


                pop     COLUMN
                pop     ROW
                ret
DisplayEquip    ENDP
msg_b_CRLF      DB     0E1h,"b",13,10,0
msg_equip1      DB     0E1h," BIOS ",0
msg_equip2      DB     0E1h,"׸ ",0
ENDIF

;--------------------------------------------------------
;       MEMtoROM        5000:0-->ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
MEMtoROM        PROC    near
                mov     es,SegMMapIDEBIOS
                cld
                mov     cx,2000h/2      ; 8KB
                push    cx
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                push    si
                mov     ax,MEMseg
                push    ds
                mov     ds,ax   ; ds=MEMseg, es=IDE BIOSRAMwindow
           rep  movsw
                pop     ds
                pop     si
                pop     cx
                ret
MEMtoROM        ENDP

;--------------------------------------------------------
;       ROMtoMEM        ds=D800:0-->5000:0
;--------------------------------------------------------
ROMtoMEM        PROC    near
                mov     dx,SegPhysIDEBIOS   ; DXɐ^IDE BIOS̃ZOg
                cld
                mov     cx,2000h/2      ; 8KB
                sub     si,si
                sub     di,di
                mov     bx,MEMseg
                push    ds
                mov     ds,dx   ; DS=DX=^IDE BIOSZOg
                mov     es,bx   ; ES=BX=MEMseg
          rep   movsw
                mov     al,ModeID
                mov     es:[0007h],al
                pop     ds
                ret
ROMtoMEM        ENDP

;--------------------------------------------------------
;       ROMRAM486_IDE  (ex)     A-mate
;--------------------------------------------------------
ROMRAM486_IDE   PROC    near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowAddr        ; address C000 or E000h.
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                ret
ROMRAM486_IDE   ENDP
;--------------------------------------------------------
RAMROM486_IDE   PROC    near
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowNative      ; address 8000h or 10000h
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window access disable =bit2=1
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                mov     dx,043Fh ;
                mov     al,0A0h  ; Invalidate CPU cache
                out     dx,al
                ret
RAMROM486_IDE   ENDP

;------------------------------------------------------------
;       ModelCheckAB      Ap,As,Ae  BA,BX, Ce
;------------------------------------------------------------
ModelCheckAB1   PROC   near
                mov     al,MachineID
                cmp     al,00h ; A-mate 1
                je      Machine_A1
                cmp     al,80h ; A-mate 1 (H)
                je      Machine_A1
                cmp     al,01h  ; Alterd BX,BA
                je      Machine_B1
                cmp     al,02h  ; Ce
                je      Machine_C1
                mov     MachineType,8   ; Ap2,As2,Af
                cmp     al,05h  ; Af
                je      Machine_A2
                cmp     al,81h  ; Af
                je      Machine_A2
                cmp     al,06h  ; Ap2,As2
                je      Machine_A2
                cmp     al,82h  ; Ap2,As2
                je      Machine_A2
                mov     MachineType,0
Machine_A2:     stc     ; Ap2,As2,Af
                ret
Machine_C1:     mov     MachineType,4   ; 4=Ce
                clc
                ret
Machine_B1:     mov     MachineType,2   ; 2=BA,BX
                clc
                ret
Machine_A1:     mov     MachineType,1   ; Ap,As,Ae
                clc
                ret
ModelCheckAB1   ENDP

;------------------------------
include e:\asmlib\putstrCS.inc      ; \[`
include setmode6.s
include ideptcom.s
;------------------------------
ProgramSize     equ     ( offset CodeEnd - offset Excode )
include xc4m1AB.s

;-----------------------------------------
ExCodeEnd       label byte      ; DO NOT MOVE or REMOVE
        DB      0,0,"ROM̏nE̔ւ.",0,0
        DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
code    ends
        end     start
